/**********************************************************************
 * LeechCraft - modular cross-platform feature rich internet client.
 * Copyright (C) 2010-2011  Oleg Linkin
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************/

#ifndef PLUGINS_AZOTH_PLUGINS_ACETAMIDE_IRCPARTICIPANTENTRY_H
#define PLUGINS_AZOTH_PLUGINS_ACETAMIDE_IRCPARTICIPANTENTRY_H

#include "entrybase.h"

namespace LeechCraft
{
namespace Azoth
{
namespace Acetamide
{

	class IrcAccount;

	class IrcParticipantEntry : public EntryBase
	{
		Q_OBJECT
	protected:
		QString Nick_;
		QString UserName_;
		QString HostName_;
		QString RealName_;
		QString ServerID_;
		bool IsPrivateChat_;
	public:
		IrcParticipantEntry (const QString&, IrcAccount* = 0);

		IAccount* GetParentAccount () const;

		ICLEntry::Features GetEntryFeatures () const;
		ICLEntry::EntryType GetEntryType () const;

		QString GetEntryName () const;
		void SetEntryName (const QString&);

		virtual QString GetEntryID () const = 0;

		QStringList Variants () const;

		QString GetUserName () const;
		void SetUserName (const QString& user);

		QString GetHostName () const;
		void SetHostName (const QString& host);

		QString GetRealName () const;
		void SetRealName (const QString& realName);

		QString GetServerID () const;

		bool IsPrivateChat () const;
		void SetPrivateChat (bool isPrivate);
	private slots:
		void handleClosePrivate ();
	};
}
}
}

#endif // PLUGINS_AZOTH_PLUGINS_ACETAMIDE_IRCPARTICIPANTENTRY_H
