/**********************************************************************
 * LeechCraft - modular cross-platform feature rich internet client.
 * Copyright (C) 2006-2014  Georg Rudoy
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************/

#ifndef PLUGINS_AZOTH_PLUGINS_XOOX_USERMOOD_H
#define PLUGINS_AZOTH_PLUGINS_XOOX_USERMOOD_H
#include <QString>
#include "pepeventbase.h"

namespace LeechCraft
{
namespace Azoth
{
namespace Xoox
{
	class UserMood : public PEPEventBase
	{
	public:
		enum Mood
		{
			MoodEmpty = -1,
			Afraid,
			Amazed,
			Amorous,
			Angry,
			Anoyed,
			Anxious,
			Aroused,
			Ashamed,
			Bored,
			Brave,
			Calm,
			Cautious,
			Cold,
			Confident,
			Confused,
			Contemplative,
			Contented,
			Cranky,
			Crazy,
			Creative,
			Curious,
			Dejected,
			Depressed,
			Disappointed,
			Disgusted,
			Dismayed,
			Distracted,
			Embarrassed,
			Envious,
			Excited,
			Flirtatious,
			Frustrated,
			Grateful,
			Grieving,
			Grumpy,
			Guilty,
			Happy,
			Hopeful,
			Hot,
			Humbled,
			Humiliated,
			Hungry,
			Hurt,
			Impressed,
			In_awe,
			In_love,
			Indignant,
			Interested,
			Intoxicated,
			Invincible,
			Jealous,
			Lonely,
			Lost,
			Lucky,
			Mean,
			Moody,
			Nervous,
			Neutral,
			Offended,
			Outraged,
			Playful,
			Proud,
			Relaxed,
			Relieved,
			Remorseful,
			Restless,
			Sad,
			Sarcastic,
			Satisfied,
			Serious,
			Shocked,
			Shy,
			Sick,
			Sleepy,
			Spontaneous,
			Stressed,
			Strong,
			Surprised,
			Thankful,
			Thirsty,
			Tired,
			Undefined,
			Weak,
			Worried
		};
	private:
		Mood Mood_;
		QString Text_;
	public:
		static QString GetNodeString ();
		
		QXmppElement ToXML () const;
		void Parse (const QDomElement&);
		QString Node () const;
		
		PEPEventBase* Clone () const;
		
		Mood GetMood () const;
		void SetMood (Mood);
		QString GetMoodStr () const;
		void SetMoodStr (const QString&);
		
		QString GetText () const;
		void SetText (const QString&);
	};
}
}
}

#endif
