/**********************************************************************
 * LeechCraft - modular cross-platform feature rich internet client.
 * Copyright (C) 2010-2012  Oleg Linkin
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************/

#pragma once

#include <QDialog>
#include "ui_addeditentrydialog.h"

namespace LeechCraft
{
namespace Blogique
{
namespace Metida
{
	class LJProfile;

	enum AddTypeEntry
	{
		ATENone,
		ATEFriend,
		ATEGroup
	};

	class AddEditEntryDialog : public QDialog
	{
		Q_OBJECT

		Ui::AddEditEntryDialog Ui_;

		enum GroupRoles
		{
			RealGroupId = Qt::UserRole + 1
		};

		enum AddTypeRoles
		{
			AddType = Qt::UserRole + 2
		};

		LJProfile *Profile_;
		QColor BackgroundColor_;
		QColor ForegroundColor_;
		uint GroupMask_;

	public:
		AddEditEntryDialog (LJProfile *profile, AddTypeEntry type = ATENone, QWidget *parent = 0);

		QString GetUserName () const;
		void SetUserName (const QString& name);
		QString GetBackgroundColorName () const;
		void SetBackgroundColor (const QColor& clr);
		QString GetForegroundColorName () const;
		void SetForegroundColor (const QColor& clr);
		uint GetGroupMask () const;
		void SetGroupMask (uint mask);

		QString GetGroupName () const;
		void SetGroupName (const QString& name);
		bool GetAcccess () const;
		void SetAccess (bool isPublic);

		AddTypeEntry GetAddTypeEntry () const;
		void ShowAddTypePossibility (bool show);
		void SetCurrentAddTypeEntry (AddTypeEntry entry);

		void accept ();
	private slots:
		void on_SelectBackgroundColor__released ();
		void on_SelectForegroundColor__released ();
		void on_SelectGroups__released ();
	};
}
}
}
