/**********************************************************************
 * LeechCraft - modular cross-platform feature rich internet client.
 * Copyright (C) 2006-2014  Georg Rudoy
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************/

#pragma once

#include <QWizardPage>
#include <interfaces/structures.h>
#include "ui_imimportpage.h"

class QStandardItemModel;
class QStandardItem;

namespace LeechCraft
{
namespace NewLife
{
namespace Common
{
	class IMImportPage : public QWizardPage
	{
		Q_OBJECT
	protected:
		Ui::IMImportPage Ui_;

		QStandardItemModel *AccountsModel_;

		static QObject* S_Plugin_;
	public:
		enum Roles
		{
			AccountData = Qt::UserRole + 1
		};

		enum Column
		{
			AccountName,
			JID,
			ImportAcc,
			ImportHist
		};

		static void SetPluginInstance (QObject*);

		IMImportPage (QWidget* = 0);

		bool isComplete () const;
		int nextId () const;
		void initializePage ();
	protected:
		virtual void FindAccounts () = 0;
		virtual void SendImportAcc (QStandardItem*) = 0;
		virtual void SendImportHist (QStandardItem*) = 0;
	protected slots:
		virtual void handleAccepted ();
	signals:
		void gotEntity (const LeechCraft::Entity&);
	};
}
}
}
