/**********************************************************************
 * LeechCraft - modular cross-platform feature rich internet client.
 * Copyright (C) 2010-2011  Oleg Linkin
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************/

#ifndef PLUGINS_POSHUKU_PLUGINS_ONLINEBOOKMARKS_ACCOUNTSETTINGS_H
#define PLUGINS_POSHUKU_PLUGINS_ONLINEBOOKMARKS_ACCOUNTSETTINGS_H

#include <QWidget>
#include <util/util.h>
#include <interfaces/ibookmarksservice.h>
#include "ui_accountssettings.h"

class QStandardItemModel;
class QStandardItem;

namespace LeechCraft
{
namespace Poshuku
{
namespace OnlineBookmarks
{
	class AccountsSettings : public QWidget
	{
		Q_OBJECT

		Ui::AccountsSettings Ui_;

		QHash<QStandardItem*, IBookmarksService*> Item2Service_;
		QHash<QStandardItem*, IAccount*> Item2Account_;
		QHash<QByteArray, QObject*> Id2Account_;
		QHash<IBookmarksService*, QWidget*> Service2AuthWidget_;
		QStandardItemModel *AccountsModel_;
		bool Scheduled_;
		QWidget *LastWidget_;
		QHash<QAction*, IBookmarksService*> Action2Service_;
	public:
		AccountsSettings ();
		~AccountsSettings ();

		void InitServices ();
		QStandardItemModel* GetAccountsModel () const;
		void UpdateDates ();
	private:
		QModelIndex GetServiceIndex (QObject*) const;
		void ScheduleResize ();
	public slots:
		void accept ();
	private slots:
		void resizeColumns ();

		void on_Delete__clicked ();
		void on_Auth__clicked ();
		void on_Register__clicked ();
		void on_AccountsView__clicked (const QModelIndex&);
		void on_AddAccount__triggered (QAction*);
		void on_Close__clicked ();

		void addAccount (QObjectList);
	signals:
		void accountRemoved (QObject*);
	};
}
}
}

#endif // PLUGINS_POSHUKU_PLUGINS_ONLINEBOOKMARKS_ACCOUNTSETTINGS_H
